//
// File: SmoothCu.cpp
// SmoothCurtain v.298 (first release)
//
// VNAP cgeffect plugin - made in RVPF[Ricanet VNAP Plugin Factory], Rica
//
// original work : VNAPȸ, AMIHK
/////////////////////////////////////////////////////////////////////////////

#include <ddraw.h>
#include <math.h>

extern "C" __declspec(dllexport) int CGEffect(LPDIRECTDRAWSURFACE7 lpScreen, 
											  LPDIRECTDRAWSURFACE7 lpBackSurface, 
											  LPDIRECTDRAWSURFACE7 lpCGSurface, 
											  LPDIRECTDRAWSURFACE7 lpBufferSurface, 
											  LPDIRECTDRAWSURFACE7 lpTemporarySurface, 
											  DWORD dwEffectTime, DWORD dwPos,
											  BOOL* bNotice, RECT* prcWindow)
{
	DDSURFACEDESC2       ddsd;
	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC2));
	ddsd.dwSize = sizeof(ddsd);

	// BufferSurface ̹ Ϳ Pitch մϴ.
	lpBufferSurface->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
	lpBufferSurface->Unlock(NULL);
	LPDWORD lpBufferData = (LPDWORD)ddsd.lpSurface;
	DWORD dwSurfacePitch = (DWORD)ddsd.lPitch/4;

	// CGSurface ̹ ͸ մϴ.
	lpCGSurface->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
	lpCGSurface->Unlock(NULL);
	LPDWORD lpCGData = (LPDWORD)ddsd.lpSurface;

	// BackSurface ̹ ͸ մϴ.
	lpBackSurface->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
	lpBackSurface->Unlock(NULL);
	LPDWORD lpBackData = (LPDWORD)ddsd.lpSurface;

	//   ǵ  ̾ ӽô.
	////////////////////////////////////////////////

	// 16Ʈ,  
	LPWORD wpBackData = (LPWORD)lpBackData;
	LPWORD wpCGData = (LPWORD)lpCGData;
	LPWORD wpBufferData = (LPWORD)lpBufferData;

	//   ̺
	DWORD *apBack32[768];
	DWORD *apCG32[768];
	DWORD *apBuffer32[768];
	WORD *apBack16[768];
	WORD *apCG16[768];
	WORD *apBuffer16[768];

	int iBackLastX = 0;

	for( int i=0; i<(int)ddsd.dwHeight; i++ )
	{
		apBack32[i] = &( lpBackData[i*dwSurfacePitch] );
		apCG32[i] = &( lpCGData[i*dwSurfacePitch] );
		apBuffer32[i] = &( lpBufferData[i*dwSurfacePitch] );
		apBack16[i] = (WORD*) &( lpBackData[i*dwSurfacePitch] );
		apCG16[i] = (WORD*) &( lpCGData[i*dwSurfacePitch] );
		apBuffer16[i] = (WORD*) &( lpBufferData[i*dwSurfacePitch] );
	} 

	DWORD dwStartingTime = GetTickCount();


	while( GetTickCount()-dwStartingTime < dwEffectTime && *bNotice!=FALSE )
	{
		DWORD dwClock = GetTickCount()-dwStartingTime;

		if(ddsd.ddpfPixelFormat.dwRGBBitCount == 16) // 16Ʈ 
		{
			double t = (double)dwClock / dwEffectTime;
			int left = int( t*(ddsd.dwWidth+dwPos) - dwPos );
			
			int x, y;
			for( x=0; x<int(dwPos); x++ )
			{
				if( left+x < 0 || left+x >= int(ddsd.dwWidth) ) continue;

				int alpha1 = 256 * x / dwPos;
				int alpha2 = 256-alpha1;
				
				for( y=0; y<int(ddsd.dwHeight); y++ )
				{
					int lx = left+x;

					#define MASK_BASE6		0x003f  // 00000000 00111111
					#define MASK_BASE5		0x001f  // 00000000 00011111

					int color1 = apCG16[y][lx];
					int red1 = (color1 >> 11) & MASK_BASE5;
					int green1 = (color1 >> 5) & MASK_BASE6;
					int blue1 = (color1) & MASK_BASE5;

					int color2 = apBuffer16[y][lx];
					int red2 = (color2 >> 11) & MASK_BASE5;
					int green2 = (color2 >> 5) & MASK_BASE6;
					int blue2 = (color2) & MASK_BASE5;

					int color3 = ((red1*alpha1 + red2*alpha2)>>8<<11) +
								 ((green1*alpha1 + green2*alpha2)>>8<<5) +
								 ((blue1*alpha1 + blue2*alpha2)>>8);

					apBack16[y][lx] = color3;
				}
			}

			// ڿ ִ ȭ ֱ
			int limit = left;

			for( y=0; y<(int)ddsd.dwHeight; y++ )
			{
				for( x=iBackLastX; x<limit; x++ )
					if( (DWORD)x<ddsd.dwWidth )
						apBack16[y][x] = apBuffer16[y][x];
			}
			iBackLastX = limit;



		
		/*
			int x, y;

			// ̺
			int P = (x1+x2)/2;
			int Q = (y1+y2)/2;
			double L = sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) )/2;
			double D = -0.15;
			double T = 0.01;
			double t = (double)dwClock/dwEffectTime;

			double tt = abs( (t-0.5)*2 );

			double M = 2*( pow(300, -pow(tt, 1.3)) - 1/300);

			//double M = 0.01/( (0.3-t)*(0.3-t)+0.01 );
			
			// ̵
			int alpha2 = int(256*(t-0.4)/0.6);
			int alpha1 = 256-alpha2;

			if( t<0.4 )
			{
				alpha1 = 256;
				alpha2 = 0;
			}

			int dx, dy;
			for( y=y1; y<y2; y++ )
			{
				// ߽κ 
				dy = y-Q;

				UCHAR *pTarget = (UCHAR*)(lpBackData + y*dwSurfacePitch);

				for( x=x1; x<x2; x++ )
				{
					dx = x-P;						// ߽κ 
					double d = sqrt(dx*dx + dy*dy);	// ߽κ Ÿ
					double ux = dx/d;				// ߽κ 
					double uy = dy/d;

					double tt = (t-0.5)*2*L;
					if( smoothstop==false && t>0.5 ) //  κ ̺ ȿ ֱ
						tt = 0;						

					double mag = 0.001* ( (d-tt)*(L-(d-tt)) ); //  ڵ
					if( d-tt<0 || L-(d-tt)<0 )
						mag = 0;

					double c = mag*sin(D*d + T*dwClock); //  ڵ

					if( d<L )
					{
						int ox = int(x+ux*c);
						int oy = int(y+uy*c);

#define MASK_BASE6		0x003f  // 00000000 00111111
#define MASK_BASE5		0x001f  // 00000000 00011111

						int color1 = wpCGData[oy*dwSurfacePitch*2+ox];
						int red1 = (color1 >> 11) & MASK_BASE5;
						int green1 = (color1 >> 5) & MASK_BASE6;
						int blue1 = (color1) & MASK_BASE5;

						int color2 = wpBufferData[oy*dwSurfacePitch*2+ox];
						int red2 = (color2 >> 11) & MASK_BASE5;
						int green2 = (color2 >> 5) & MASK_BASE6;
						int blue2 = (color2) & MASK_BASE5;

						int color3 = ((red1*alpha1 + red2*alpha2)>>8<<11) +
									 ((green1*alpha1 + green2*alpha2)>>8<<5) +
									 ((blue1*alpha1 + blue2*alpha2)>>8);

						wpBackData[y*dwSurfacePitch*2+x] = color3;
					}
					
				} // ~for x

			} // ~for y			
*/
		}
		else // 32Ʈ 
		{
			double t = (double)dwClock / dwEffectTime;
			int left = int( t*(ddsd.dwWidth+dwPos) - dwPos );
			
			int x, y;
			for( x=0; x<int(dwPos); x++ )
			{
				if( left+x < 0 || left+x >= int(ddsd.dwWidth) ) continue;

				int alpha1 = 256 * x / dwPos;
				int alpha2 = 256-alpha1;
				
				for( y=0; y<int(ddsd.dwHeight); y++ )
				{
					int lx2 = (left+x) << 2;
					UCHAR *pSource1 = (UCHAR*)(apCG32[y]);
					UCHAR *pSource2 = (UCHAR*)(apBuffer32[y]);
					UCHAR *pTarget = (UCHAR*)(apBack32[y]);

					pTarget[lx2  ] = (pSource1[lx2  ]*alpha1 + pSource2[lx2  ]*alpha2)>>8;
					pTarget[lx2+1] = (pSource1[lx2+1]*alpha1 + pSource2[lx2+1]*alpha2)>>8;					
					pTarget[lx2+2] = (pSource1[lx2+2]*alpha1 + pSource2[lx2+2]*alpha2)>>8;
				}
			}

			// ڿ ִ ȭ ֱ
			int limit = left;

			for( y=0; y<(int)ddsd.dwHeight; y++ )
			{
				for( x=iBackLastX; x<limit; x++ )
					if( (DWORD)x<ddsd.dwWidth )
						apBack32[y][x] = apBuffer32[y][x];
			}
			iBackLastX = limit;

		} // if 16bit/32bit

		lpScreen->Blt( prcWindow, lpBackSurface, NULL, DDBLT_WAIT, NULL );
	}

	//  ڰ threadcgeffect ŵ  , while ߿  
	// BackSurface ȭȿ   µǾ ִ ̹Ƿ 
	//  κп    ؾ մϴ.
	// Fadeȿ    Ǵ ̹̹Ƿ, BackSurface BufferSurface մϴ.
	lpBackSurface->Blt( NULL, lpBufferSurface, NULL, DDBLT_WAIT, NULL );

	return 0;
}
