//
// File: snow.cpp
// snow v.2930 (first release)
//
// VNAP cgeffect2 plugin - made in RVPF[Ricanet VNAP Plugin Factory], Rica
//
// original work : VNAPȸ, AMIHK
/////////////////////////////////////////////////////////////////////////////

#include <ddraw.h>
#include <stdio.h>

#define CGEFFECT_PITCH 20

// ȭȿ   
static DDSURFACEDESC2       ddsd;

static LPDIRECTDRAWSURFACE7 lpddBack;
static LPDIRECTDRAWSURFACE7 lpddCG;

static LPDWORD pBackSurface;
static LPDWORD pCGSurface;

static LPWORD pwBackSurface;
static LPWORD pwCGSurface;

static DWORD dwSurfacePitch;
static WORD wSurfacePitch;
static int iWindowWidth, iWindowHeight;
static bool bPixelFormatIs16;

//static int iPos, iCurrentPos, iValue,iWidth;
//static DWORD dwTime;

static DWORD dwStartTime;
static DWORD dwLastTime;
static int nSnows;
static int iSnowX[100], iSnowY[100];
static int iSnowVx[100], iSnowVy[100];
static int iMaxVx, iMaxAx, iMaxVy, iMinVy;
static int iSnowSize;

// ݵ Լ ̿ ϰ  ֽñ ٶϴ.
// Լ̳ ڰ ٸ ,   ʽϴ.

//-----------------------------------------------------------------------------
// Name: BeginCGEffect2
// Desc:  ȭȿ ۵  ȣǴ ԼԴϴ.
//		  Լ ǥ Ķ͸ ϰ ʱصξٰ 
//		 UpdateFrame Լ մϴ.
//-----------------------------------------------------------------------------
// strParam				: cgeffect2 Ŀǵ ڿ Է¹ ĶͰ Ʈ ɴϴ.
// lpBackSurface		: ȭ鿡 µǱ  ̹ Ǵ ǥ Դϴ. 
//						   ϴ  BackSurface  ScreenSurface ˴ϴ.
// lpCGSurface			:  ̹ Ǿ ִ ǥԴϴ. ȭȿ ۵Ǵ  â 
//						  ̹ CGSurface Ǿ ֽϴ.
// lpBufferSurface		:   ǥ Ǿ ֽϴ.
extern "C" __declspec(dllexport) int BeginCGEffect2(char* strParam,
													LPDIRECTDRAWSURFACE7 lpBackSurface, 
													LPDIRECTDRAWSURFACE7 lpCGSurface, 
													LPDIRECTDRAWSURFACE7 lpBufferSurface)			
{
	// Lock޼ҵ带  DDSURFACEDESC2 ü ǥ  ؿ  ֽϴ.
	// ̹Ϳ  Ҷ DDESURFACEDESC2 ü   lpSurface մϴ.
	// Lock  Ŀ Unlock޼ҵ ݵ Lock Ǯ մϴ.

	// ǥ  DDSURFACEDESC2 ü մϴ.
	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC2));
	ddsd.dwSize = sizeof(ddsd);

	// BackSurface ̹ Ϳ Pitch մϴ.
	lpddBack = lpBackSurface;
	lpddBack->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
	pBackSurface = (LPDWORD)ddsd.lpSurface;
	dwSurfacePitch = (DWORD)ddsd.lPitch/4;
	lpddBack->Unlock(NULL);

	iWindowWidth = ddsd.dwWidth;
	iWindowHeight = ddsd.dwHeight;

	// CGSurface ̹ ͸ մϴ.
	lpddCG = lpCGSurface;
	lpddCG->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
	pCGSurface = (LPDWORD)ddsd.lpSurface;
	lpddCG->Unlock(NULL);
	
	bPixelFormatIs16 = (ddsd.ddpfPixelFormat.dwRGBBitCount == 16);

	// 16bit 带   
	pwBackSurface = (LPWORD)pBackSurface;
	pwCGSurface = (LPWORD)pCGSurface;
	wSurfacePitch = ddsd.lPitch/2;
	
	// ð 
	dwLastTime = dwStartTime = GetTickCount();

	// Ķ ȯ

	int iRes = sscanf(strParam, "%d %d %d %d %d %d",
		&nSnows, &iMaxVx, &iMaxVy, &iMinVy, &iMaxAx, &iSnowSize);
	if( iRes<1 ) nSnows = 50;
	if( iRes<2 ) iMaxVx = 10 << 8; else iMaxVx <<= 8;
	if( iRes<3 ) iMaxVy = 60 << 8; else iMaxVy <<= 8;
	if( iRes<4 ) iMinVy = 25 << 8; else iMinVy <<= 8;
	if( iRes<5 ) iMaxAx = 5 << 8;  else iMaxAx <<= 8;
	if( iRes<6 ) iSnowSize = 1300;

	//  ġ ǥ ʱȭ
	srand(GetTickCount());
	if( nSnows>=100 )
		nSnows = 100;

	int i;
	for( i=0; i<nSnows; i++ ) 
	{
		iSnowX[i] = (rand() % int(ddsd.dwWidth)) << 8;
		iSnowY[i] = (rand() % int(ddsd.dwHeight) - int(ddsd.dwHeight)) << 8;
		iSnowVx[i] = ((rand() % (iMaxVx*2)) - iMaxVx ); 
		iSnowVy[i] = ((rand() % (iMaxVy-iMinVy)) + iMinVy );
	}

	return 0;
}

//-----------------------------------------------------------------------------
// Name: UpdateFrame
// Desc:   Ҷ  Լ ȣǰ  Ŀ â BackSurface
//		   ȭ鿡 µ˴ϴ.
//-----------------------------------------------------------------------------
// bSurfaceRestored		: ȭȿ   ڰ Ǯũ/带
//						  ȯ , ǥ ޸𸮿 ٰ ٽ Ǿ ޸𸮻
//						  ּҰ ٲϴ.   bSurfaceRestored true ,
//						  lpBackSurface  ּҰ ɴϴ.
//						  bSurfaceRestored  false϶ lpBackSurface NULL
//						  ֽϴ.
extern "C" __declspec(dllexport) int UpdateFrame(BOOL bSurfaceRestored,
												 LPDIRECTDRAWSURFACE7 lpBackSurface, 
												 LPDIRECTDRAWSURFACE7 lpCGSurface, 
												 LPDIRECTDRAWSURFACE7 lpBufferSurface)
{
	// ǥġ 缳
	if(bSurfaceRestored)
	{
		ZeroMemory(&ddsd, sizeof(DDSURFACEDESC2));
		ddsd.dwSize = sizeof(ddsd);

		lpddBack = lpBackSurface;
		lpddBack->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
		pBackSurface = (LPDWORD)ddsd.lpSurface;
		dwSurfacePitch = (DWORD)ddsd.lPitch/4;
		lpddBack->Unlock(NULL);

		lpddCG = lpCGSurface;
		lpddCG->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
		pCGSurface = (LPDWORD)ddsd.lpSurface;
		lpddCG->Unlock(NULL);
	
		bPixelFormatIs16 = (ddsd.ddpfPixelFormat.dwRGBBitCount == 16);

		pwBackSurface = (LPWORD)pBackSurface;
		pwCGSurface = (LPWORD)pCGSurface;
		wSurfacePitch = ddsd.lPitch/2;
	}

	int i;

	int iTimeGap = GetTickCount() - dwLastTime;
	dwLastTime = GetTickCount();
	
	// ó
	for( i=0; i<nSnows; i++ )
	{
		iSnowY[i] += iSnowVy[i]*iTimeGap/1000;
		iSnowX[i] += iSnowVx[i]*iTimeGap/1000;

		iSnowVx[i] += (rand()%(iMaxAx*2)-iMaxAx+1)*iTimeGap/1000;
		if( iSnowVx[i] > iMaxVx ) iSnowVx[i] = iMaxVx;
		if( iSnowVx[i] < -iMaxVx ) iSnowVx[i] = -iMaxVx;

		if( iSnowY[i]>>8 > int(ddsd.dwHeight)+40 )
		{
			iSnowY[i] = -(40<<8);
			iSnowX[i] = (rand() % int(ddsd.dwWidth)) << 8;
			iSnowVy[i] = ((rand() % (iMaxVy-iMinVy)) + iMinVy );
		}
	}

	// Ϲ ȭȿ     ̹ ϴ κ
	lpddBack->Blt(NULL, lpddCG, NULL, DDBLT_WAIT, NULL);

	if(bPixelFormatIs16) // 16bit
	{
		for( i=0; i<nSnows; i++ )
		{
			register int p = iSnowX[i]>>8;
			register int q = iSnowY[i]>>8;
			register int r = iSnowSize * (iSnowVy[i]) / (iMaxVy-iMinVy);
			register int rs8 = r >> 8;
			register int rs8_2 = (r*r) >> 16;

			register int x, y;
			if( -r<=p && p<int(ddsd.dwWidth)+r &&
				-r<=q && q<int(ddsd.dwHeight)+r ) //  ȭ ȿ 
			{
				for( y=q-rs8; y<=q+rs8; y++ )
				{
					// ǥ  ˻
					if( y<0 ) continue;
					if( y>=int(ddsd.dwHeight)) break;

					for( x=p-rs8; x<=p+rs8; x++ )
					{
						// ǥ  ˻
						if( x<0 ) continue;
						if( x>=int(ddsd.dwWidth)) break;

						register int dist2 = (y-q)*(y-q) + (x-p)*(x-p);
						if( dist2 <= rs8_2 )
						{
#define MASK_BASE6		0x003f  // 00000000 00111111
#define MASK_BASE5		0x001f  // 00000000 00011111
#define WHITE16			0xFFFF

							register int alpha2 = (256 - 256*dist2/rs8_2) * iSnowVy[i] / iMaxVy;
							register int alpha1 = 256-alpha2;

							register WORD color1 = pwBackSurface[y*wSurfacePitch + x];
							register WORD color2 = WHITE16;

							register int red1 = (color1 >> 11) & MASK_BASE5;
							register int green1 = (color1 >> 5) & MASK_BASE6;
							register int blue1 = (color1) & MASK_BASE5;
							register int red2 = (color2 >> 11) & MASK_BASE5;
							register int green2 = (color2 >> 5) & MASK_BASE6;
							register int blue2 = (color2) & MASK_BASE5;

							pwBackSurface[y*wSurfacePitch + x]
									=((red1*alpha1 + red2*alpha2)>>8<<11) +
									 ((green1*alpha1 + green2*alpha2)>>8<<5) +
									 ((blue1*alpha1 + blue2*alpha2)>>8);

						} // ~if dist2<=rs

					} // ~for x
				} // ~for y 
			} // ~if snow is in screen
		} // ~for each snow
	
	}
	else // 32bit
	{
		for( i=0; i<nSnows; i++ )
		{
			register int p = iSnowX[i]>>8;
			register int q = iSnowY[i]>>8;
			register int r = iSnowSize * (iSnowVy[i]) / (iMaxVy-iMinVy);
			register int rs8 = r >> 8;
			register int rs8_2 = (r*r) >> 16;

			register int x, y;
			if( -r<=p && p<int(ddsd.dwWidth)+r &&
				-r<=q && q<int(ddsd.dwHeight)+r ) //  ȭ ȿ 
			{
				for( y=q-rs8; y<=q+rs8; y++ )
				{
					// ǥ  ˻
					if( y<0 ) continue;
					if( y>=int(ddsd.dwHeight)) break;

					for( x=p-rs8; x<=p+rs8; x++ )
					{
						// ǥ  ˻
						if( x<0 ) continue;
						if( x>=int(ddsd.dwWidth)) break;

						register int dist2 = (y-q)*(y-q) + (x-p)*(x-p);
						if( dist2 <= rs8_2 )
						{
#define WHITE		0xFFFFFFFF
#define MASK_BASE8	0x000000ff
#define MASK_MID8	0x0000ff00
#define MASK_HIGH8	0x00ff0000
							register DWORD pixel1 = pBackSurface[y*ddsd.dwWidth + x];
							register DWORD pixel2 = WHITE;

							register int alpha2 = (256 - 256*dist2/rs8_2) * iSnowVy[i] / iMaxVy;
							register int alpha1 = 256-alpha2;
							

							pBackSurface[y*ddsd.dwWidth + x] =
							((( pixel1 & MASK_BASE8)*alpha1 + (pixel2 & MASK_BASE8)*alpha2) >>8) |
							((((pixel1>>8)&MASK_BASE8) * alpha1 + ((pixel2>>8) & MASK_BASE8) * alpha2) &MASK_MID8 ) |
							(((((pixel1>>16) & MASK_BASE8)*alpha1 + ((pixel2>>16) & MASK_BASE8)*alpha2)&MASK_MID8) <<8);
						} // ~if dist2<=rs

					} // ~for x
				} // ~for y 
			} // ~if snow is in screen
		} // ~for each snow
	} // ~32bit

	return 0;
}

//-----------------------------------------------------------------------------
// Name: EndCGEffect2
// Desc: ȭȿ ÿ ȣǴ ԼԴϴ.
//-----------------------------------------------------------------------------
extern "C" __declspec(dllexport) int EndCGEffect2()
{
	lpddBack->Blt(NULL, lpddCG, NULL, DDBLT_WAIT, NULL);
	return 0;
}