#pragma once

struct SetPixel16
{
	inline void operator() ( int x, int y, int r, int g, int b, int alpha )
	{
		#define MASK_BASE6		0x003f  // 00000000 00111111
		#define MASK_BASE5		0x001f  // 00000000 00011111

		register WORD base = pwBackSurface[y*wSurfacePitch + x];
		register int baseR = (base >> 11) & MASK_BASE5;
		register int baseG = (base >> 5)  & MASK_BASE6;
		register int baseB = (base)       & MASK_BASE5;
		register int baseA = 255-alpha;

		pwBackSurface[y*wSurfacePitch + x] =
				( (baseA*baseR + alpha*r)>>8<<11 ) + 
				( (baseA*baseG + alpha*g)>>8<<5 ) + 
				( (baseA*baseB + alpha*b)>>8 );

		#undef MASK_BASE5
		#undef MASK_BASE6
	}

	inline int MakeR( byte r )
	{
        return r >> 3;
	}
	inline int MakeG( byte g )
	{
        return g >> 2;
	}
	inline int MakeB( byte b )
	{
        return b >> 3;
	}
};

struct SetPixel32
{
	inline void operator() ( int x, int y, int r, int g, int b, int alpha )
	{
		#define MASK_BASE8	0x000000ff

		register DWORD base  = pBackSurface[y*ddsd.dwWidth + x];
		register int   baseR = (base >> 16) & MASK_BASE8;
		register int   baseG = (base >> 8 ) & MASK_BASE8;
		register int   baseB = (base)       & MASK_BASE8;
		register int   baseA = 255-alpha;

		pBackSurface[y*ddsd.dwWidth + x] =
				( (baseA*baseR + alpha*r)>>8<<16 ) + 
				( (baseA*baseG + alpha*g)>>8<<8 ) + 
				( (baseA*baseB + alpha*b)>>8 );

		#undef MASK_BASE8
	}

	inline int MakeR( byte r )
	{
        return r;
	}
	inline int MakeG( byte g )
	{
        return g;
	}
	inline int MakeB( byte b )
	{
        return b;
	}
};