#include "stdafx.h"
#include "Timer.h"

#include "Util.h"


void Timer::Reset()
{
	// initialize timestamps
	BOOL queryPerformanceFrequencyResult = QueryPerformanceFrequency((_LARGE_INTEGER*)&timeFreq);
	ThrowIf( !queryPerformanceFrequencyResult );
	QueryPerformanceCounter((_LARGE_INTEGER*)&timeStamp); 
	frameTime = 33.3F / 1000.0F;
	fps = 0;
	fpsNotUpdatedTime = 0.0F;
	fpsNotUpdatedCount = 0;
	accumulatedClock = 0.0F;
}

void Timer::Update()
{
	// update timestamps
	__int64 currentTime;
	QueryPerformanceCounter((_LARGE_INTEGER*)&currentTime);
	frameTime = (float)((double)(currentTime-timeStamp) / timeFreq );
	
	// ̻  ּȭϱ ؼ.
	if( frameTime <= 0.0F ) frameTime = 0.00001F;
	if( frameTime >= 2.0F ) frameTime = 2.0F;

	timeStamp = currentTime;
	
	accumulatedClock += frameTime;

	// update fps
	fpsNotUpdatedTime += frameTime;
	fpsNotUpdatedCount++;
	if( fpsNotUpdatedTime > 0.5F )
	{
		fps = fpsNotUpdatedCount / fpsNotUpdatedTime;
		fpsNotUpdatedTime = 0.0F;
		fpsNotUpdatedCount = 0;
	}
}