#ifndef _UTIL_H_INCLUDED_
#define _UTIL_H_INCLUDED_
#pragma once

#include <exception>

#define SafeRelease(x)			if(x){ x->Release(); x=0; }
/*#define SafeReleaseArray(x,n)	if(x){ for(int i=0;i<n;i++) \
											if(x[i]){ \
												x[i]->Release(); \
												x[i]=NULL;} \
										x=NULL; }
										*/
/*
#define SafeDelete(x)			if(x){ delete x; x=0; }
*/
#define SafeDeleteArray(x)		if(x){ delete[] x; x=0; }
#define ThrowIfNull(x)			if(!(x)){ _ThrowExceptionAt("Fatal error : Failed to initialize " ## #x, __FILE__, __LINE__ ); }
#define ThrowIf(x)				if(x){ _ThrowExceptionAt("Fatal error : " ## #x, __FILE__, __LINE__ ); }

#ifndef _DEBUG
	#define Trace
//	#define ASSERT
#else
	#define Trace				_Trace
//	#define ASSERT(x)			if(!(x)){ _ThrowExceptionAt("Assertion fail : " ## #x, __FILE__, __LINE__ ); }
#endif

void _ThrowExceptionAt( const char* message, const char* file, int line );
void _Trace( const char* fmt, ... );
inline DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }

#endif